import java.awt.*;
import java.io.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.*;
public class MpointEApplet extends JApplet implements Runnable,KeyListener{
    Image back;
    Graphics h;
    Thread t;
    String[]levs=new String[10000];
    boolean veryfirst=true;
    boolean newlev=true;
    boolean hold=false;
    boolean alla=false;
    boolean loadscore=true;
    int ydrift=-6;
    int xdrift=0;
    int direction=0;
    int xpos=320;
    int ypos=460;
    int[][]data=new int[32][22];
    int levnum=0;
    int points=0;
    int fahns=0;
    int leben=3;
    boolean resetb=false;
    static MpointEApplet app;
    Image rand,stein,point,fahne,xpo,spread,all,boden,pirat,links,oben,rechts,unten;
    private static final long serialVersionUID = -2698442766649440150L;
    public void init(){
        app=this;
        t=new Thread(this);
        xpo=getImage("xpob.gif");
        boden=getImage("boden.gif");
        point=getImage("point.gif");
        spread=getImage("spread.gif");
        stein=getImage("stein.gif");
        pirat=getImage("pirat.gif");
        fahne=getImage("fahne.gif");
        all=getImage("all.gif");
        rand=getImage("rand.gif");
//        links=getToolkit().getImage("links.gif");
//        oben=getToolkit().getImage("oben.gif");
//        rechts=getToolkit().getImage("rechts.gif");
//        unten=getToolkit().getImage("unten.gif");
        MediaTracker tracker=new MediaTracker(this);
        tracker.addImage(all,0);
        tracker.addImage(xpo,0);
        tracker.addImage(boden,0);
        tracker.addImage(point,0);
        tracker.addImage(spread,0);
        tracker.addImage(stein,0);
        tracker.addImage(pirat,0);
        tracker.addImage(fahne,0);
        tracker.addImage(rand,0);
        try{
            tracker.waitForID(0);
        }
        catch(Exception e){}
        back=createImage(700,700);
        h=back.getGraphics();
        setSize(650,510);
        setLayout(null);
        setVisible(true);
        addKeyListener(this);
        setFocusable(true);
        requestFocus();
        t.start();
    }
    public static Image getImage(String filename){
        try{
            URL url=MpointEApplet.app.getClass().getResource("/"+filename);
            Image img=MpointEApplet.app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=getClass().getResourceAsStream(filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public synchronized void reset(){
        ydrift=-6;
        xdrift=0;
        direction=0;
        xpos=320;
        ypos=460;
        for(int i=0;i<32;i++){
            for(int j=0;j<22;j++){
                data[i][j]=0;
            }
        }
        levnum=0;
        points=0;
        fahns=0;
        leben=3;
        veryfirst=false;
        newlev=true;
    }
    public synchronized void paint(Graphics g){
        if(veryfirst){
            loadlevlist();
            veryfirst=false;
        }
        if(newlev){
            loadnewlev();
            direction=0;
            xdrift=0;
            ydrift=-6;
            newlev=false;
        }
        if(levs[levnum].equals("END")||levs[levnum].equals("")){
            if(loadscore){
//                new ScoreFrame(leben,points);
                loadscore=false;
            }
            for(int i=0;i<30;i++){
                for(int j=0;j<22;j++){
                    data[i][j]=0;
                }
            }
        }
        for(int i=0;i<30;i++){
            for(int j=0;j<22;j++){
                int v=data[i][j];
                if(v==0)h.drawImage(boden,i*20+20,j*20+50,this);
                if(v==1)h.drawImage(point,i*20+20,j*20+50,this);
                if(v==2)h.drawImage(spread,i*20+20,j*20+50,this);
                if(v==3)h.drawImage(stein,i*20+20,j*20+50,this);
                if(v==4)h.drawImage(pirat,i*20+20,j*20+50,this);
                if(v==5)h.drawImage(fahne,i*20+20,j*20+50,this);
                h.setColor(Color.black);
                if(v==6)h.fillRect(i*20+20,j*20+50,20,20);
                if(v==7)h.drawImage(all,i*20+20,j*20+50,this);
                if(v==8)h.drawImage(links,i*20+20,j*20+50,this);
                if(v==9)h.drawImage(oben,i*20+20,j*20+50,this);
                if(v==10)h.drawImage(rechts,i*20+20,j*20+50,this);
                if(v==11)h.drawImage(unten,i*20+20,j*20+50,this);
            }
        }
        for(int i=0;i<32;i++){
            h.drawImage(rand,i*20,30,this);
            h.drawImage(rand,i*20,490,this);
        }
        for(int i=0;i<22;i++){
            h.drawImage(rand,0,i*20+50,this);
            h.drawImage(rand,620,i*20+50,this);
        }
        xpos+=xdrift;
        ypos+=ydrift;
        collision(h);
        if(levs[levnum].equals("END")||levs[levnum].equals("")){
            h.setColor(Color.WHITE);
            h.drawString("You have won",100,100);
        }
        h.drawImage(xpo,xpos,ypos,this);
        g.drawImage(back,10,0,this);
    }
    public void collision(Graphics g){
        boolean ret=false;
        if(ypos<50||ypos>470){
            ydrift=-ydrift;
            ret=true;
        }
        if(xpos<20||xpos>600){
            xdrift=-xdrift;
            ret=true;
        }
        if(!ret){
        int x=(xpos-10)/20;
        int y=(ypos-40)/20;
        int f=data[x][y];
        if(f==1){
            points++;
            data[x][y]=0;
        }
        if(f==2){
            int prob=(int)(Math.random()*2);
            if(prob==0){
                xdrift=(int)(Math.random()*13)-6;
            }
            else{
                ydrift=(int)(Math.random()*13)-6;
            }
        }
        if(f==3){
            if(direction==0){
                ydrift=-ydrift;
            }
            else{
                xdrift=-xdrift;
            }
        }
        if(f==4||f==6){
            leben--;
            xpos=320;
            ypos=460;
            direction=0;
            xdrift=0;
            ydrift=-6;
            if(leben<=0){
                levnum=0;
                points=0;
                newlev=true;
                leben=3;
            }
        }
        if(f==8){
            direction=1;
            xdrift=-6;
            ydrift=0;
        }
        if(f==9){
            direction=0;
            xdrift=0;
            ydrift=-6;
        }
        if(f==10){
            direction=1;
            xdrift=6;
            ydrift=0;
        }
        if(f==11){
            direction=0;
            xdrift=0;
            ydrift=6;
        }
        if(f==7)alla=true;
        if(f!=7)alla=false;
        if(f==5){
            fahns--;
            data[x][y]=0;
            if(fahns==0){
                levnum++;
                newlev=true;
                xpos=320;
                ypos=460;
            }
        }
        }
    }
    public void loadnewlev(){
        if(levs[levnum].equals("END")||levs[levnum].equals("")){
            return;
        }
        try{
            fahns=0;
            InputStream in=getInputStream("/"+levs[levnum]);
            DataInputStream dis=new DataInputStream(in);
            for(int i=0;i<30;i++){
                for(int j=0;j<22;j++){
                    data[i][j]=0;
                    if(j<22)data[i][j]=dis.read();
                    if(data[i][j]==5)fahns++;
                }
            }
            dis.close();
            in.close();
        }
        catch(Exception e){
        }
    }
    public void loadlevlist(){
        try{
            InputStream in=getInputStream("/levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(in));
            int i=0;
            String l="";
            while((l=dis.readLine())!=null){
                levs[i]=l;
                i++;
            }
            dis.close();
            in.close();
            levs[i]="END";
        }
        catch(Exception e){
        }
    }
    public void run(){
        while(true){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){};
            if(resetb==true){
                reset();
                resetb=false;
            }
            repaint();
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        process(e);
    }
    public void keyReleased(KeyEvent e){
    }
    public synchronized void process(KeyEvent evt){
        int key=evt.getKeyCode();
            if(key==KeyEvent.VK_ENTER){
                resetb=true;
            }
            if(key==KeyEvent.VK_RIGHT){
                if(direction==0){
                    if(!alla&&xdrift<6)xdrift++;
                }
                else{
                    if(!alla&&ydrift<6)ydrift++;
                }
            }
            if(key==KeyEvent.VK_LEFT){
                if(direction==0){
                    if(!alla&&xdrift>-6)xdrift--;
                }
                else{
                    if(!alla&&ydrift>-6)ydrift--;
                }
            }
    }
}
